import cv2

from dev.Camera import Camera
from dev.Recorder import Recorder
from dev.BackgroundSubstractor import BackgroundSubstractor
from dev.GmgInit import GmgInit

if __name__ == "__main__":
# 153, 587
#     camera = Camera('./rec/21_03_2021-13_01_02.avi') #i= 500 snow 3
    # camera = Camera('./rec/12_04_2021-17_12_34.avi') #i= 550 snow 1
    # camera = Camera('./rec/21_03_2021-12_56_11.avi') #i= 240 snow 2
    # camera = Camera('./rec/27_03_2021-08_46_20.avi') #i= 484 wind 3
    # camera = Camera('./rec/23_03_2021-10_56_22.avi') #i= 131 wind 2
    # camera = Camera('./rec/27_03_2021-08_46_20.avi') #i= 128 wind 3
    # camera = Camera('./rec/17_05_2021-14_52_20.avi') #i= 524 rain 1
    # camera = Camera('./rec/17_05_2021-14_49_41.avi') #i= 560 rain 2
    camera = Camera('./rec/17_05_2021-14_49_41.avi') #i= 560 rain 3

    # camera = Camera('./rec/06_05_2021-22_59_39.avi') #i= 500
    # camera.set_resolution(640, 480)
    # camera.set_fps(30)
    # camera.get_camera_properties()
    # camera.init_auto_balance()
    # recorder = Recorder(640, 480)
    gmgSubstractor = GmgInit()
    gmgSubstractor.set_smooting(0)

    gmgSubstractor2 = BackgroundSubstractor('GMG')
    i = 0
    while(True):    
        ret, frame = camera.read()
        i = i + 1
        frame_p = gmgSubstractor.pre_process(frame)
        gmgFrameO = gmgSubstractor.apply(frame_p)
        gmgFrameT = gmgSubstractor.process(gmgFrameO)

        #original frame
        gmgFrame2 = gmgSubstractor2.apply(frame)

        cv2.imshow('frame', frame)
        # cv2.imshow('GMG', gmgFrame)
        cv2.imshow('GMG test', gmgFrameT)
        cv2.imshow('GMG orig', gmgFrame2)
        print(i)
        if i == 587:
            cv2.imwrite('./GMG4_3.jpg', gmgFrameT)
            cv2.imwrite('./color.jpg', frame)
            cv2.imwrite('./orig.jpg', gmgFrame2)
            cv2.imwrite('./raw.jpg', gmgFrameO)

        # recorder.write(frame)

        if cv2.waitKey(1) & 0xFF == ord('q'): 
            break
  
    camera.release() 
    cv2.destroyAllWindows() 

